function [E] = euler(image_name, image_type)
A = imread(image_name, image_type);
B = double(im2bw(A));
B = 1 - B;
rows = size(B,1);
cols = size(B,2);
C = zeros(rows+2, cols+2);
C = imposingSmallMatOntoBigMat(B, C, [2,2]);
no_of_convexities = 0;
no_of_concavities = 0;

for i = 2:rows+1
    for j = 2:cols+1
        if C(i,j)==1
            sum = C(i-1,j-1) + C(i-1,j) + C(i,j-1);
            if sum==0
                no_of_convexities = no_of_convexities + 1;
            end
        end
        if C(i,j)==0
            sum = C(i,j+1) + C(i+1,j) + C(i+1,j+1);
            if sum==3
                no_of_concavities = no_of_concavities + 1;
            end
        end
    end
end

no_of_convexities
no_of_concavities

euler_number = no_of_convexities - no_of_concavities